package map2esql.popup.actions;

import java.io.*;
import java.util.*;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.xml.sax.*;
import java.util.regex.*;

public class Map2ESQL {
	// Constants
	private static final boolean 		silent			= false;
	
	// Statics
	private static DocumentBuilder 		builder 		= null;
	private static SAXParseException 	parseException 	= null;
	private static boolean				setupDone 		= false;
	private static Stack				elementStack	= null;
	private static int					errorCount		= 0;
	private static StringBuffer			esqlBuf			= new StringBuffer();
	private static String				ind				= "";
	private static String 				outd 			= "";
	private static int					tabCount		= 0;
	private static String 				singleTab		= "        ";
	private static String				variableTracker = "A";
	private static int					variableNumber	= 1;
	private static HashMap 				loopHashMap 	= new HashMap();
	private static HashMap 				occursHashMap 	= new HashMap();
	private static HashMap 				refHashMap	 	= new HashMap();
	private static ArrayList			inScopeRefs		= new ArrayList();
	private static int					InsertOutRootNow = 0;	
	private static boolean				OutRootDecAlreadyExists = false;
	private static boolean				OutRootDecAlreadyExistsIf = false;	
	private static int					OutRootInsertPoint = 0;
	private static String				OutRootIfInsert = "";
	private static String				OutRootIfTab	= "";	
	private static boolean				InBodyRef		= false;
	private static boolean				OutBodyRef		= false;
	// For xpath functions
	private static boolean				esqlempty		= false;
	private static String				esql_empty 		= "";
	private static boolean				esqlexists		= false;
	private static String				esql_exists		= "";
	private static boolean				esqlnot			= false;
	private static String				esql_not 		= "";
	private static boolean				esqlyearfromdateTime = false;
	private static String				esql_yearfromdateTime = "";	
	private static boolean				esqlmonthfromdateTime = false;
	private static String				esql_monthfromdateTime = "";	
	private static boolean				esqldayfromdateTime = false;
	private static String				esql_dayfromdateTime = "";	
	private static boolean				esqlhoursfromdateTime = false;
	private static String				esql_hoursfromdateTime = "";	
	private static boolean				esqlminutesfromdateTime = false;
	private static String				esql_minutesfromdateTime = "";	
	private static boolean				esqlsecondsfromdateTime = false;
	private static String				esql_secondsfromdateTime = "";	
	private static boolean				esqlyearfromdate = false;
	private static String				esql_yearfromdate = "";	
	private static boolean				esqlmonthfromdate = false;
	private static String				esql_monthfromdate = "";
	private static boolean				esqldayfromdate = false;
	private static String				esql_dayfromdate = "";	
	private static boolean				esqlhoursfromtime = false;
	private static String				esql_hoursfromtime = "";	
	private static boolean				esqlminutesfromtime = false;
	private static String				esql_minutesfromtime = "";	
	private static boolean				esqlsecondsfromtime = false;
	private static String				esql_secondsfromtime = "";	
	private static boolean				esqlyearsfromduration = false;
	private static String				esql_yearsfromduration = "";	
	private static boolean				esqlmonthsfromduration = false;
	private static String				esql_monthsfromduration = "";	
	private static boolean				esqldaysfromduration = false;
	private static String				esql_daysfromduration = "";		
	private static boolean				esqlhoursfromduration = false;
	private static String				esql_hoursfromduration = "";	
	private static boolean				esqlminutesfromduration = false;
	private static String				esql_minutesfromduration = "";	
	private static boolean				esqlsecondsfromduration = false;
	private static String				esql_secondsfromduration = "";	
	
	private static String doMatch(String expr, String subj) {
		Pattern p = Pattern.compile(expr);
		Matcher m = p.matcher(subj);
		StringBuffer replaced = new StringBuffer();
		while(m.find()) {						
			m.appendReplacement(replaced, functionToESQL(m.group()));				
		}		
		m.appendTail(replaced);
		return replaced.toString();		
	}
	
	/**
	 * doSetup - Initialise DocumentBuidlerFactory and DocumentBuilder (called internally)
	 */
	private static void doSetup() 
		throws ParserConfigurationException
	{
		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
		factory.setNamespaceAware(true);

		// Create non-validating DocumentBuilder
		builder = factory.newDocumentBuilder();
		builder.setErrorHandler(new ErrorHandler() {
			public void error(SAXParseException spe) throws SAXException {
				parseException = spe;
			}
			public void fatalError(SAXParseException spe) throws SAXException {
				parseException = spe;
			}
			public void warning(SAXParseException spe) throws SAXException {
				parseException = spe;
			}
		});
		
		elementStack = new Stack();
		elementStack.push("OutputRoot");
			
		setupDone = true;
		
	}
	
	/**
	 * log
	 */
	private static void log(String message) {
		if(!silent)	System.out.print(message);
		
	}

	/**
	 * walk - Recursive method that walks a given tree node
	 */
	private static void walk(Node node) {
		//boolean willPop = processNode(node);
		boolean willPop = false;

		// Process the node
		int result = processNode(node);

		if (result==1) {willPop = false;}
		else if (result==2) {willPop = true;}
		else if (result==3) {willPop = false;node = node.getNextSibling();}
		
		// A node either has children or a value
		if(node.hasChildNodes()) {		
			
			// Walk children (recursion)
			NodeList kids = node.getChildNodes();
			int numKids = kids.getLength();
			
			for(int i=0; i<numKids; i++) {
				Node kid = kids.item(i);
				walk(kid);
			}
		}
		
		// Pop the element stack if we exit this method
		if(willPop) {
			String popped = (String)elementStack.pop();
		}
	}

	/**
	 * walkFor - Recursive method that walks a given tree node 
	 * ...specially adapted for ForLoops so it calls processNodeFor instead of processNode
	 */
	private static void walkFor(Node node, String index, boolean insertindex, String sourceindexinsert) {

		//boolean willPop = processNode(node);
		boolean willPop = false;

		// Process the node
		int result = processNodeFor(node, index, insertindex, sourceindexinsert);

		if (result==1) {willPop = false;}
		else if (result==2) {willPop = true;}
		else if (result==3) {willPop = false;node = node.getNextSibling();}
		
		// A node either has children or a value
		if(node.hasChildNodes()) {		
			
			// Walk children (recursion)
			NodeList kids = node.getChildNodes();
			int numKids = kids.getLength();
			
			for(int i=0; i<numKids; i++) {
				Node kid = kids.item(i);
				walkFor(kid, index, false, sourceindexinsert);
			}
		}
		
		// Pop the element stack if we exit this method
		if(willPop) {
			String popped = (String)elementStack.pop();
		}
	}
	
	/**
	 * show
	 */
	private static void show(Node node) {
		String nn = node.getNodeName();
		if(!nn.equals("#text")) {
			log(node.getNodeName()+": ");	
			NamedNodeMap attrs = node.getAttributes();
			if(attrs!=null) {
				int attrsLength = attrs.getLength();				
				for(int i=0; i<attrsLength; i++) {
					Node attr = attrs.item(i);
					log(attr.getNodeName()+"="+attr.getNodeValue()+" ");
				}
			}
			
		}
	}

	/**
	 * processNode - Returns whether an element was pushed onto the stack
	 */
	private static int processNode(Node node) {
		if(node.getNodeName().equals("value")) {
			// This is a value leaf representing a RHS value
			String ex = toESQL(node);
			ex = ex.replaceAll("''(.*)''","'$1'");			
			
			//Substitution of inscope references 
			ex = substituteRefs(ex);
			String Path = getElementPath();
			// In addition to setting path, getElementPath() also flags if we are about to start work on the msg body
			// for the first time, by setting InsertOutRootNow to be true.
			// Prepared the OutputRoot's message body, by creating root and reference to it			
			if (InsertOutRootNow==1 && !OutRootDecAlreadyExists) {
				if (OutBodyRef) {
					if (OutRootInsertPoint == 0) {
						esqlBuf.append(getTab()+"CREATE LASTCHILD OF OutputRoot DOMAIN('"+outd+"');\n");
						esqlBuf.append(getTab()+"DECLARE OutBodyRef REFERENCE TO OutputRoot."+outd+";\n");
					}
					else {						
						OutRootIfInsert = OutRootIfTab+"CREATE LASTCHILD OF OutputRoot DOMAIN('"+outd+"');\n"+OutRootIfTab+"DECLARE OutBodyRef REFERENCE TO OutputRoot."+outd+";\n";						
					}
				}
				InsertOutRootNow=InsertOutRootNow+1;
				//InsertOutRootNow = false;
				OutRootDecAlreadyExists = true;				
			}
			esqlBuf.append(getTab()+"SET "+Path+" = "+ex+";\n");
			//esqlBuf.append(getTab()+"SET "+getElementPath()+" = "+ex+";\n");
			//esqlBuf.append(getTab()+"SET "+getElementPath()+" = "+toESQL(node)+";\n");
		} else {
			String attr = getAttrValue(node, "xsi:type");
			if(attr!=null && attr.indexOf("QualifyStatement")!=-1) {
				// This is an IF node, so we'll treat it separately
				processIfNode(node);
				return(3);
			} 
			else if(attr!=null && attr.indexOf("ForEachStatement")!=-1) {
				// This is a FOR LOOP node, so we'll treat it separately
				forLoop(node);
				return(3);
			} 			
			else {
				String mn = getAttrValue(node,"mappableName");
				String mntype = getAttrValue(node,"xsi:type");
				if (mntype!=null) {
					if (mntype.equals("msg:AttributeMsgStatement")) {				
						if (outd.equals("XML") || outd.equals("XMLNS")) {mn = "(XML.Attribute)"+mn;}
						if (outd.equals("XMLNSC")) {mn = "(XMLNSC.Attribute)"+mn;}
						if (outd.equals("SOAP")) {mn = "(XMLNSC.Attribute)"+mn;}
					}
				}				
				if(mn!=null) {								    
					elementStack.push(mn);
					return(2);
				}
			}
		}		

		return(1);
	}

	/**
	 * processNodeFor - Returns whether an element was pushed onto the stack
	 */
	private static int processNodeFor(Node node, String index, boolean insertindex, String sourceindexinsert) {

		if(node.getNodeName().equals("value")) {
						
			// This is a value leaf representing a RHS value
			String expr = toESQL(node).replaceFirst(sourceindexinsert,sourceindexinsert+"["+index+"]");
						
			//Check for reference insertion ...			
			expr = substituteRefs(expr);
						
			String Path = getElementPath();
			// In addition to setting path, getElementPath() also flags if we are about to start work on the msg body
			// for the first time, by setting InsertOutRootNow to be true.
			// Prepared the OutputRoot's message body, by creating root and reference to it
			if (InsertOutRootNow==1 && !OutRootDecAlreadyExists) {
				if (OutBodyRef) {
					if (OutRootInsertPoint == 0) {
						esqlBuf.append(getTab()+"CREATE LASTCHILD OF OutputRoot DOMAIN('"+outd+"');\n");
						esqlBuf.append(getTab()+"DECLARE OutBodyRef REFERENCE TO OutputRoot."+outd+";\n");
					}
					else {						
						OutRootIfInsert = OutRootIfTab+"CREATE LASTCHILD OF OutputRoot DOMAIN('"+outd+"');\n"+OutRootIfTab+"DECLARE OutBodyRef REFERENCE TO OutputRoot."+outd+";\n";						
					}			
					//esqlBuf.append(getTab()+"CREATE LASTCHILD OF OutputRoot DOMAIN('"+outd+"');\n");
					//esqlBuf.append(getTab()+"DECLARE OutBodyRef REFERENCE TO OutputRoot."+outd+";\n");
				}
				InsertOutRootNow = InsertOutRootNow +1;
				//InsertOutRootNow = false;
				OutRootDecAlreadyExists = true;
			}
			esqlBuf.append(getTab()+"SET "+Path+" = "+expr+";\n");
			//esqlBuf.append(getTab()+"SET "+getElementPath()+" = "+expr+";\n");

		} else {
			String attr = getAttrValue(node, "xsi:type");
			if(attr!=null && attr.indexOf("QualifyStatement")!=-1) {
				// This is an IF node, so we'll treat it separately
				processIfNode(node);
				return(3);
			} 
			else if(attr!=null && attr.indexOf("ForEachStatement")!=-1) {
				// This is a FOR LOOP node, so we'll treat it separately
				forLoop(node);
				return(3);
			} 			
			else {
				String mn = getAttrValue(node,"mappableName");
				String mntype = getAttrValue(node,"xsi:type");
				if (mntype!=null) {
					if (mntype.equals("msg:AttributeMsgStatement")) {				
						if (outd.equals("XML") || outd.equals("XMLNS")) {mn = "(XML.Attribute)"+mn;}
						if (outd.equals("XMLNSC")) {mn = "(XMLNSC.Attribute)"+mn;}					
						if (outd.equals("SOAP")) {mn = "(XMLNSC.Attribute)"+mn;}
					}
				}
				if (insertindex) {mn = mn+"["+index+"]";}
				if(mn!=null) {								    
					elementStack.push(mn);
					return(2);
				}
			}
		}		

		//return(false);
		return(1);
	}
	
	
	
	/**
	 * processIfNode - Processes a Condition subtree; 
	 */
	private static void processIfNode(Node node) {	
				
		// The approach in this method is to:
		// i)  Iterate through Condition blocks in order they occur adding their content
		// ii) Add processing of the Default (ELSE) block at the end if it exists
		// I do this because multiple condition blocks are possible, and the else block is not
		// guaranteed to occur at the end in the node tree!
				
		NodeList kids = node.getChildNodes();
		int numKids = kids.getLength();
		int countConditions = 0;
		
		for(int i=0; i<numKids; i++) {
			Node kid = kids.item(i);
			String type = getAttrValue(kid, "xsi:type");
			if(type!=null) {
				if (type.indexOf("ConditionStatement")!=-1) {			
					Node conditionNode = searchForChild(kid,"condition",null,null,false);
					String condition = conditionToESQL(getAttrValue(conditionNode, "text"));
					Node nextlevelNode = searchForChild(kid,"blockContents",null,null,false);
					if (countConditions==0) {
						//  Need to mark the current point in esqlBuf, so that if the IF statement processing
						// includes the creation of OutRef for first time, it can be inserted into esqlBuf
						// at the correct level (outside of the IF block).
						if (OutRootInsertPoint == 0) {OutRootInsertPoint = esqlBuf.length();}
						OutRootIfTab = getTab();
						esqlBuf.append(getTab()+"IF "+condition+" THEN\n");countConditions++;addTabCount();}
					else {minusTabCount();esqlBuf.append(getTab()+"ELSEIF "+condition+" THEN\n");addTabCount();}
					//if (nextlevelNode!=null) {walk(nextlevelNode);}
					while (nextlevelNode!=null) {
						walk(nextlevelNode);
						nextlevelNode = nextlevelNode.getNextSibling();
					}
					
				}
			}
		}				
		for(int j=0; j<numKids; j++) {
			Node kid = kids.item(j);
			String type = getAttrValue(kid, "xsi:type");
			if(type!=null) {
				if (type.indexOf("DefaultStatement")!=-1) {
					minusTabCount();
					esqlBuf.append(getTab()+"ELSE\n");
					addTabCount();
					Node nextlevelNode = searchForChild(node,"blockContents",null,null,false);
					if (nextlevelNode!=null) {walk(nextlevelNode);}
				}
			}
		}
		minusTabCount();
		esqlBuf.append(getTab()+"END IF;\n");
		//if (InsertOutRootNow == 1) {
		//if (InsertOutRootNow > 0 && !OutRootDecAlreadyExists) {			
		if (InsertOutRootNow > 0 && !OutRootDecAlreadyExistsIf) {
			esqlBuf.insert(OutRootInsertPoint,OutRootIfInsert);
			OutRootDecAlreadyExistsIf = true;
		}


	}

	/**
	 * searchForChild - Search immediate children of a node for one that matches
	 *                  the name and/or the existence of an attribute or the given 
	 *                  attribute name-value match
	 */
	private static Node searchForChild(Node node, String name, String attrName, String attrValue,
										boolean deepSearch) {
		NodeList kids = node.getChildNodes();
		if(kids==null) return(null);
		
		int numKids = kids.getLength();
		
		for(int i=0; i<numKids; i++) {
			Node kid = kids.item(i);
			String nn = kid.getNodeName();

			if(!nn.equals("#text")) {
				// Calculate name match
				boolean nameMatch = name==null || nn.equals(name);
	
				// Calculate attribute match
				String av = getAttrValue(kid, attrName);
				boolean attrMatch = attrName==null || (attrValue==null && av!=null) || (attrValue.equals(av));
				
				if(nameMatch && attrMatch) {
					return(kid);
				} else if(deepSearch) {
					Node ret = searchForChild(kid, name, attrName, attrValue, deepSearch);
					if(ret!=null) return(ret);
				}
			}
		}
		
		return(null);
	}

	/**
	 * toESQL - Converts a value node to an ESQL expression
	 */
	private static String toESQL(Node node) {
		String text = getAttrValue(node, "text");
		String type = getAttrValue(node, "xsi:type");

		if(type.indexOf("LiteralExpression")!=-1) {
			return("'"+text.replaceAll("\"","")+"'");
		} else if(type.indexOf("MappableReferenceExpression")!=-1) {
			return(xPathToESQL(text));
		} else if(type.indexOf("FunctionCallExpression")!=-1) {
			return(functionToESQL(text));
		} else {
			return("???");
		}
	}

	/**
	 * forLoop - Deals with encountered for loops in the message map
	 */

	private static void forLoop(Node node) {
	
		Node sourceNode = searchForChild(node,"source",null,null,false);
		String sourcetext = getAttrValue(sourceNode, "text");
		
		NodeList kids = node.getChildNodes();
		int numKids = kids.getLength();
						
		//String var1 = Character.toString(variableTracker);
		String var1 = variableTracker+variableNumber;
		//variableTracker++;
		variableNumber++;
		//String var2 = Character.toString(variableTracker);
		String var2 = variableTracker+variableNumber;
		//variableTracker++;
		variableNumber++;
		
		// Use same technique for outref insertions, as used by IF constructs 
		// At this stage we dont know if the loop will reference the output body,
		// so we need to set the OutRootInsertPoint just in case!
		if (OutRootInsertPoint == 0) {OutRootInsertPoint = esqlBuf.length();}
		OutRootIfTab = getTab();

		esqlBuf.append("\n"+getTab()+"DECLARE "+var1+" INTEGER 1;\n");
		String correlname = xPathToESQL(sourcetext);
		esqlBuf.append(getTab()+"DECLARE "+var2+" INTEGER CARDINALITY("+correlname+"[]);\n");
		occursHashMap.put(correlname,var1);
		
		// Used for reference substitution
		refHashMap.put(var1+"_REF",correlname+"["+var1+"]");
		// Add reference to my array of those references which are currently in scope
		inScopeRefs.add(var1+"_REF");
		// Declare a reference for possible reuse ... 
		esqlBuf.append(getTab()+"DECLARE "+var1+"_REF REFERENCE TO "+correlname+"[1];\n");		

		StringTokenizer split = new StringTokenizer(sourcetext, "/");
		String lastToken = "";
		while(split.hasMoreTokens()) {
			lastToken = split.nextToken();
		}
		
		loopHashMap.put(lastToken,var1);
		esqlBuf.append(getTab()+"WHILE "+var1+" <= "+var2+" DO\n");
		addTabCount();

		// Declare a reference for possible reuse ... Should probably change this to be a MOVE with the DECLARE elsewhere
		esqlBuf.append(getTab()+"MOVE "+var1+"_REF TO "+correlname+"["+var1+"];\n");		
		
		for(int i=0; i<numKids; i++) {
			Node kid = kids.item(i);
			if (kid.getNodeName().equals("blockContents")) {			
				walkFor(kid, var1, true, xPathToESQL(sourcetext));
			}
		}		
				
		esqlBuf.append(getTab()+"SET "+var1+" = "+var1+" + 1;\n");		
		minusTabCount();
		esqlBuf.append(getTab()+"END WHILE;\n\n");
		if (InsertOutRootNow > 0 && !OutRootDecAlreadyExistsIf) {
			esqlBuf.insert(OutRootInsertPoint,OutRootIfInsert);
			OutRootDecAlreadyExistsIf = true;
		}
		if (!OutRootDecAlreadyExists || !OutRootDecAlreadyExistsIf ) {
			// This is situation where contents of While loop didnt reference Output body, 
			// so need to reset insertion point to be zero. 
			OutRootInsertPoint = 0;
		}
		inScopeRefs.remove(var1+"_REF");
	}
		
	/**
	 * conditionToESQL - Converts an IF expression to ESQL format
	 * 
	 * Example:
	 * $source/RECORD_01/CTR-CTRCT/CTR.PROD_ = 'CRS' and $source/RECORD_01/HEADER-01/HEA.CS-IS = 'CS' 
	 */
	

	
	private static String conditionToESQL(String condition) {
	
		// Substitute for msgmap: functions
		condition = doMatch("msgmap:[a-z]*\\(\\$source(/[a-zA-Z_0-9:/]*)*\\)", condition);
		// Substitute for xpath: functions
		condition = doMatch("fn:[a-z]*\\(\\$source(/[a-zA-Z_0-9:/]*)*\\)", condition);
		// Substitute for esql: functions
		condition = doMatch("esql:[a-z]*\\(\\$source(/[a-zA-Z_0-9:/]*)*\\)", condition);
		
		// Capitalise "or" & "and" (Ben thinks this is better style :)
		condition = condition.replaceAll(" or ", " OR ");
		condition = condition.replaceAll(" and ", " AND ");	
    		
		StringBuffer buf = new StringBuffer();
		
		// Tokenise on spaces
		StringTokenizer tok = new StringTokenizer(condition," ");
		while(tok.hasMoreTokens()) {
			String t = tok.nextToken();
			
			// If it looks like a field reference, ESQL-ise it
			if(!t.startsWith("'") && (t.indexOf("$source")!=-1 || t.indexOf("/")!=-1))
				t = xPathToESQL(t);

			// I don't like lower-case ESQL logical operators!
			else if(t.equals("and") || t.equals("or"))
				t = t.toUpperCase();
			
			buf.append(t);
			if(tok.hasMoreTokens())
				buf.append(" ");
		}

		return(buf.toString());		
	}

	/**
	 * getAttrValue
	 */
	private static String getAttrValue(Node node, String attrName) {
		try {
			if(node==null) return(null);
				
			NamedNodeMap attrs = node.getAttributes();
			if(attrs==null) return(null);
			
			Node attr = attrs.getNamedItem(attrName);
			return(attr==null ? null : attr.getNodeValue());

		} catch(Exception e) {
			// Not sure what causes this exception
			return null;
		}
	}

	/**
	 * xPathToESQL - Converts XPath syntax to ESQL dotted syntax
	 */
	private static String xPathToESQL(String xp) {
		StringBuffer out = new StringBuffer();
		StringTokenizer tok = new StringTokenizer(xp, "/");
		int counter = 1;
		while(tok.hasMoreTokens()) {
			String t = tok.nextToken();
			if (t.substring(0,1).equals("@")) {
				if (ind.equals("XML") || ind.equals("XMLNS")) {t = "(XML.Attribute)"+t.substring(1,t.length());}
				if (ind.equals("XMLNSC")) {t = "(XMLNSC.Attribute)"+t.substring(1,t.length());}
				if (ind.equals("SOAP")) {t = "(XMLNSC.Attribute)"+t.substring(1,t.length());}
				if (ind.equals("MRM")) {t = t.substring(1,t.length());}
			}
			if (t.replaceAll("^\\s+", "").equals("$source")) {out.append("InputRoot");}
			else if(counter==2 && t.equals("Properties"))
					{out.append("Properties");}
			else if(counter==2 && t.equals("MQMD"))
					{out.append("MQMD");}					
			else if(counter==2 && t.equals("MQCFH"))
					{out.append("MQCFH");}
			else if(counter==2 && t.equals("MQCIH"))
					{out.append("MQCIH");}
			else if(counter==2 && t.equals("MQDLH"))
					{out.append("MQDLH");}
			else if(counter==2 && t.equals("MQIIH"))
					{out.append("MQIIH");}	
			else if(counter==2 && t.equals("MQMDE"))
					{out.append("MQMDE");}			
			else if(counter==2 && t.equals("MQRFH"))
					{out.append("MQRFH");}						
			else if(counter==2 && t.equals("MQRFH2"))
					{out.append("MQRFH2");}			
			else if(counter==2 && t.equals("MQRFH2C"))
					{out.append("MQRFH2C");}			
			else if(counter==2 && t.equals("MQRMH"))
					{out.append("MQRMH");}
			else if(counter==2 && t.equals("MQSAPH"))
					{out.append("MQSAPH");}			
			else if(counter==2 && t.equals("MQWIH"))
					{out.append("MQWIH");}
			else if(counter==2 && t.equals("SMQ_BMH"))
					{out.append("SMQ_BMH");}
			else if(counter==2 && t.equals("HTTPInputHeader"))
					{out.append("HTTPInputHeader");}
			else if(counter==2 && t.equals("HTTPRequestHeader"))
					{out.append("HTTPRequestHeader");}
			else if(counter==2 && t.equals("HTTPReplyHeader"))
					{out.append("HTTPReplyHeader");}
			else if(counter==2 && t.equals("HTTPResponseHeader"))
					{out.append("HTTPResponseHeader");}
			else if(counter==2 && t.equals("JMSTransport"))
					{out.append("JMSTransport");}
			else if(counter==2 && ind.equals("MRM"))
					{out.append("MRM");}
			else if(counter==2 && ind.equals("XMLNSC"))
					{out.append("XMLNSC."+t);}
			else if(counter==2 && ind.equals("XMLNS"))
					{out.append("XMLNS."+t);}
			else if(counter==2 && ind.equals("XML"))
					{out.append("XML."+t);}			
			else if(counter==2 && t.equals("SOAP_Domain_Msg"))
				{out.append("SOAP");}
			else	
				// In order to cope with loops, need to add checks in here to see if we are midloop				
				if (loopHashMap.containsKey(t)) {out.append(t+"["+loopHashMap.get(t)+"]");}
				else {out.append(t);}					
			if(tok.hasMoreTokens()) out.append(".");			
			counter++;
		}
		
		return(out.toString());
	}

	/**
	 * functionToESQL - Converts XPath ESQL function syntax to "pure" ESQL dotted syntax
	 */
	private static String functionToESQL(String func) {
		int posColon = func.indexOf(':');
		int posOpen  = func.indexOf('(');
		int posClose = func.indexOf(')');
		
		String ret = "";
		String prefix = func.substring(0,posColon);
		String funcName = func.substring(posColon+1, posOpen);
		String xp = func.substring(posOpen+1, posClose);
		// xp can be a comma separated list of arguments ... so ...
		StringTokenizer tok = new StringTokenizer(xp, ",");
		String path = "";
		while(tok.hasMoreTokens()) {
			path = path+xPathToESQL(tok.nextToken());
			if(tok.hasMoreTokens()) {path=path+",";}			
		}		
		//String path = xPathToESQL(xp);
		if (prefix.equals("fn")) {ret=XFunc(funcName,xp);}
		else if (prefix.equals("esql")) {ret=funcName+"("+path+")";}
		else if (prefix.equals("msgmap")) {ret=MapFunc(funcName,xp);}
		else {ret=xPathToESQL(func);}
	
		return(ret);		
	}

	private static String MapFunc(String funcName, String xp) {
		String esql = "";		
		if (funcName.equals("occurrence")) {
			String correl = xPathToESQL(xp);
			if (occursHashMap.containsKey(correl.substring(0,correl.length()-4))) 
				//take off the [A1] from the end of the statement when looking up in the hash ... 
				// assuming we wont get more then 100 variables prior to a msgmap:occurrences
				{esql = occursHashMap.get(correl.substring(0,correl.length()-4)).toString();}
			else {
				// This means that X in the statement of msgmap:occurrences(X) 
				// refers to a point in the tree which has not been referred 
				// to previously in a loop, so should be given the default value of 0
				esql = "0";
			}
		}	
		return esql;
		
	}
	
	
	private static String XFunc(String funcName, String xp) {

		String esql = "";

		if (funcName.equals("concat")) {
			StringTokenizer part = new StringTokenizer(xp, ",");
			esql = xPathToESQL(part.nextToken());
			while(part.hasMoreTokens()) {
				String t = xPathToESQL(part.nextToken());
				esql = esql+" || "+t;
			}
		}
			
		if (funcName.equals("substring")) {
			StringTokenizer arg = new StringTokenizer(xp, ",");
			if (arg.countTokens() == 2) {esql = "SUBSTR("+arg.nextToken()+" FROM "+arg.nextToken()+");";}
			else {esql = "SUBSTRING("+xPathToESQL(arg.nextToken())+" FROM "+arg.nextToken()+" FOR "+arg.nextToken()+")";}			
		}
		
		if (funcName.equals("empty")) {
			esql = "xpath_empty("+xPathToESQL(xp)+")";			
			if (!esqlempty) {
				esql_empty = esql_empty+"CREATE FUNCTION xpath_empty("+variableTracker+" REFERENCE) RETURNS BOOLEAN\n";
				esql_empty = esql_empty+"BEGIN\n";		
				esql_empty = esql_empty+"RETURN NOT LASTMOVE("+variableTracker+");\n";
				esql_empty = esql_empty+"END;\n\n";
				esqlempty = true;
			}
		}
		
		if (funcName.equals("exists")) {
			esql = "xpath_exists("+xPathToESQL(xp)+")";
			if (!esqlexists) {
				esql_exists = esql_exists+singleTab+"CREATE FUNCTION xpath_exists("+variableTracker+" REFERENCE) RETURNS BOOLEAN\n";
				esql_exists = esql_exists+singleTab+"BEGIN\n";		
				esql_exists = esql_exists+singleTab+"RETURN LASTMOVE("+variableTracker+");\n";
				esql_exists = esql_exists+singleTab+"END;\n\n";
				esqlexists = true;
			}
		}

		if (funcName.equals("not")) {
			esql = "xpath_not("+xPathToESQL(xp)+")";
			if (!esqlnot) {
				esql_not = esql_not+"CREATE FUNCTION xpath_not("+variableTracker+" BOOLEAN) RETURNS BOOLEAN\n";
				esql_not = esql_not+"BEGIN\n";		
				esql_not = esql_not+"RETURN NOT "+variableTracker+";\n";
				esql_not = esql_not+"END;\n\n";
				esqlnot = true;
			}
		}

		if (funcName.equals("true")) {
			esql = "TRUE";			
		}		
		
		if (funcName.equals("false")) {
			esql = "FALSE";			
		}				
		
		if (funcName.equals("avg")) {
			esql = "(SELECT SUM("+variableTracker+") FROM "+xPathToESQL(xp)+"AS "+variableTracker+") / (SELECT COUNT(*) FROM "+xPathToESQL(xp)+");";			
		}
		
		if (funcName.equals("count")) {
			esql = "(SELECT COUNT(*) FROM "+xPathToESQL(xp)+");\n";			
		}		
		
		if (funcName.equals("max")) {
			esql = "(SELECT MAX("+variableTracker+") FROM "+xPathToESQL(xp)+" AS "+variableTracker+");\n";			
		}			

		if (funcName.equals("min")) {
			esql = "(SELECT MIN("+variableTracker+") FROM "+xPathToESQL(xp)+" AS "+variableTracker+");\n";			
		}			
		
		if (funcName.equals("sum")) {
			esql = "(SELECT SUM("+variableTracker+") FROM "+xPathToESQL(xp)+" AS "+variableTracker+");\n";			
		}	

		if (funcName.equals("year-from-dateTime")) {
			esql = "xpath_yearfromdateTime("+xPathToESQL(xp)+")";
			if (!esqlyearfromdateTime) {
				esql_yearfromdateTime = esql_yearfromdateTime+"CREATE FUNCTION xpath_yearfromdateTime("+variableTracker+" TIMESTAMP) RETURNS INTEGER\n";
				esql_yearfromdateTime = esql_yearfromdateTime+"BEGIN\n";		
				esql_yearfromdateTime = esql_yearfromdateTime+"IF ("+variableTracker+" IS NULL) THEN\n";
				esql_yearfromdateTime = esql_yearfromdateTime+"RETURN NULL;\n";
				esql_yearfromdateTime = esql_yearfromdateTime+"ELSE\n";
				esql_yearfromdateTime = esql_yearfromdateTime+"RETURN EXTRACT(YEAR FROM "+variableTracker+");\n";
				esql_yearfromdateTime = esql_yearfromdateTime+"END IF;\n";
				esql_yearfromdateTime = esql_yearfromdateTime+"END;\n\n";				
				esqlyearfromdateTime = true;
			}
		}
		
		if (funcName.equals("month-from-dateTime")) {
			esql = "xpath_monthfromdateTime("+xPathToESQL(xp)+")";			
			if (!esqlmonthfromdateTime) {
				esql_monthfromdateTime = esql_monthfromdateTime+"CREATE FUNCTION xpath_monthfromdateTime("+variableTracker+" TIMESTAMP) RETURNS INTEGER\n";
				esql_monthfromdateTime = esql_monthfromdateTime+"BEGIN\n";		
				esql_monthfromdateTime = esql_monthfromdateTime+"IF ("+variableTracker+" IS NULL) THEN\n";
				esql_monthfromdateTime = esql_monthfromdateTime+"RETURN NULL;\n";
				esql_monthfromdateTime = esql_monthfromdateTime+"ELSE\n";
				esql_monthfromdateTime = esql_monthfromdateTime+"RETURN EXTRACT(MONTH FROM "+variableTracker+");\n";
				esql_monthfromdateTime = esql_monthfromdateTime+"END IF;\n";
				esql_monthfromdateTime = esql_monthfromdateTime+"END;\n\n";				
				esqlmonthfromdateTime = true;
			}
		}
	
		if (funcName.equals("day-from-dateTime")) {
			esql = "xpath_dayfromdateTime("+xPathToESQL(xp)+")";			
			if (!esqldayfromdateTime) {
				esql_dayfromdateTime = esql_dayfromdateTime+"CREATE FUNCTION xpath_dayfromdateTime("+variableTracker+" TIMESTAMP) RETURNS INTEGER\n";
				esql_dayfromdateTime = esql_dayfromdateTime+"BEGIN\n";		
				esql_dayfromdateTime = esql_dayfromdateTime+"IF ("+variableTracker+" IS NULL) THEN\n";
				esql_dayfromdateTime = esql_dayfromdateTime+"RETURN NULL;\n";
				esql_dayfromdateTime = esql_dayfromdateTime+"ELSE\n";
				esql_dayfromdateTime = esql_dayfromdateTime+"RETURN EXTRACT(DAY FROM "+variableTracker+");\n";
				esql_dayfromdateTime = esql_dayfromdateTime+"END IF;\n";
				esql_dayfromdateTime = esql_dayfromdateTime+"END;\n\n";				
				esqldayfromdateTime = true;
			}
		}		
		
		if (funcName.equals("hours-from-dateTime")) {
			esql = "xpath_hoursfromdateTime("+xPathToESQL(xp)+")";			
			if (!esqlhoursfromdateTime) {
				esql_hoursfromdateTime = esql_hoursfromdateTime+"CREATE FUNCTION xpath_hoursfromdateTime("+variableTracker+" TIMESTAMP) RETURNS INTEGER\n";
				esql_hoursfromdateTime = esql_hoursfromdateTime+"BEGIN\n";		
				esql_hoursfromdateTime = esql_hoursfromdateTime+"IF ("+variableTracker+" IS NULL) THEN\n";
				esql_hoursfromdateTime = esql_hoursfromdateTime+"RETURN NULL;\n";
				esql_hoursfromdateTime = esql_hoursfromdateTime+"ELSE\n";
				esql_hoursfromdateTime = esql_hoursfromdateTime+"RETURN EXTRACT(HOUR FROM "+variableTracker+");\n";
				esql_hoursfromdateTime = esql_hoursfromdateTime+"END IF;\n";
				esql_hoursfromdateTime = esql_hoursfromdateTime+"END;\n\n";				
				esqlhoursfromdateTime = true;
			}
		}		
		
		if (funcName.equals("minutes-from-dateTime")) {
			esql = "xpath_minutesfromdateTime("+xPathToESQL(xp)+")";			
			if (!esqlminutesfromdateTime) {
				esql_minutesfromdateTime = esql_minutesfromdateTime+"CREATE FUNCTION xpath_minutesfromdateTime("+variableTracker+" TIMESTAMP) RETURNS INTEGER\n";
				esql_minutesfromdateTime = esql_minutesfromdateTime+"BEGIN\n";		
				esql_minutesfromdateTime = esql_minutesfromdateTime+"IF ("+variableTracker+" IS NULL) THEN\n";
				esql_minutesfromdateTime = esql_minutesfromdateTime+"RETURN NULL;\n";
				esql_minutesfromdateTime = esql_minutesfromdateTime+"ELSE\n";
				esql_minutesfromdateTime = esql_minutesfromdateTime+"RETURN EXTRACT(MINUTE FROM "+variableTracker+");\n";
				esql_minutesfromdateTime = esql_minutesfromdateTime+"END IF;\n";
				esql_minutesfromdateTime = esql_minutesfromdateTime+"END;\n\n";				
				esqlminutesfromdateTime = true;
			}
		}		
		
		if (funcName.equals("seconds-from-dateTime")) {
			esql = "xpath_secondsfromdateTime("+xPathToESQL(xp)+")";		
			if (!esqlsecondsfromdateTime) {
				esql_secondsfromdateTime = esql_secondsfromdateTime+"CREATE FUNCTION xpath_secondsfromdateTime("+variableTracker+" TIMESTAMP) RETURNS DECIMAL\n";
				esql_secondsfromdateTime = esql_secondsfromdateTime+"BEGIN\n";		
				esql_secondsfromdateTime = esql_secondsfromdateTime+"IF ("+variableTracker+" IS NULL) THEN\n";
				esql_secondsfromdateTime = esql_secondsfromdateTime+"RETURN NULL;\n";
				esql_secondsfromdateTime = esql_secondsfromdateTime+"ELSE\n";
				esql_secondsfromdateTime = esql_secondsfromdateTime+"RETURN CAST(EXTRACT(SECOND FROM "+variableTracker+") AS DECIMAL);\n";
				esql_secondsfromdateTime = esql_secondsfromdateTime+"END IF;\n";
				esql_secondsfromdateTime = esql_secondsfromdateTime+"END;\n\n";				
				esqlsecondsfromdateTime = true;
			}
		}				

		if (funcName.equals("year-from-date")) {
			esql = "xpath_yearfromdate("+xPathToESQL(xp)+")";		
			if (!esqlyearfromdate) {
				esql_yearfromdate = esql_yearfromdate+"CREATE FUNCTION xpath_yearfromdate("+variableTracker+" DATE) RETURNS INTEGER\n";
				esql_yearfromdate = esql_yearfromdate+"BEGIN\n";		
				esql_yearfromdate = esql_yearfromdate+"IF ("+variableTracker+" IS NULL) THEN\n";
				esql_yearfromdate = esql_yearfromdate+"RETURN NULL;\n";
				esql_yearfromdate = esql_yearfromdate+"ELSE\n";
				esql_yearfromdate = esql_yearfromdate+"RETURN EXTRACT(YEAR FROM "+variableTracker+");\n";
				esql_yearfromdate = esql_yearfromdate+"END IF;\n";
				esql_yearfromdate = esql_yearfromdate+"END;\n\n";				
				esqlyearfromdate = true;
			}
		}

		if (funcName.equals("month-from-date")) {
			esql = "xpath_monthfromdate("+xPathToESQL(xp)+")";		
			if (!esqlmonthfromdate) {
				esql_monthfromdate = esql_monthfromdate+"CREATE FUNCTION xpath_monthfromdate("+variableTracker+" DATE) RETURNS INTEGER\n";
				esql_monthfromdate = esql_monthfromdate+"BEGIN\n";		
				esql_monthfromdate = esql_monthfromdate+"IF ("+variableTracker+" IS NULL) THEN\n";
				esql_monthfromdate = esql_monthfromdate+"RETURN NULL;\n";
				esql_monthfromdate = esql_monthfromdate+"ELSE\n";
				esql_monthfromdate = esql_monthfromdate+"RETURN EXTRACT(MONTH FROM "+variableTracker+");\n";
				esql_monthfromdate = esql_monthfromdate+"END IF;\n";
				esql_monthfromdate = esql_monthfromdate+"END;\n\n";				
				esqlmonthfromdate = true;
			}
		}
				
		if (funcName.equals("day-from-date")) {
			esql = "xpath_dayfromdate("+xPathToESQL(xp)+")";		
			if (!esqldayfromdate) {
				esql_dayfromdate = esql_dayfromdate+"CREATE FUNCTION xpath_dayfromdate("+variableTracker+" DATE) RETURNS INTEGER\n";
				esql_dayfromdate = esql_dayfromdate+"BEGIN\n";		
				esql_dayfromdate = esql_dayfromdate+"IF ("+variableTracker+" IS NULL) THEN\n";
				esql_dayfromdate = esql_dayfromdate+"RETURN NULL;\n";
				esql_dayfromdate = esql_dayfromdate+"ELSE\n";
				esql_dayfromdate = esql_dayfromdate+"RETURN EXTRACT(DAY FROM "+variableTracker+");\n";
				esql_dayfromdate = esql_dayfromdate+"END IF;\n";
				esql_dayfromdate = esql_dayfromdate+"END;\n\n";				
				esqldayfromdate = true;
			}
		}

		if (funcName.equals("hours-from-time")) {
			esql = "xpath_hoursfromtime("+xPathToESQL(xp)+")";		
			if (!esqlhoursfromtime) {
				esql_hoursfromtime = esql_hoursfromtime+"CREATE FUNCTION xpath_hoursfromtime("+variableTracker+" TIME) RETURNS INTEGER\n";
				esql_hoursfromtime = esql_hoursfromtime+"BEGIN\n";		
				esql_hoursfromtime = esql_hoursfromtime+"IF ("+variableTracker+" IS NULL) THEN\n";
				esql_hoursfromtime = esql_hoursfromtime+"RETURN NULL;\n";
				esql_hoursfromtime = esql_hoursfromtime+"ELSE\n";
				esql_hoursfromtime = esql_hoursfromtime+"RETURN EXTRACT(HOUR FROM "+variableTracker+");\n";
				esql_hoursfromtime = esql_hoursfromtime+"END IF;\n";
				esql_hoursfromtime = esql_hoursfromtime+"END;\n\n";				
				esqlhoursfromtime = true;
			}
		}

		if (funcName.equals("minutes-from-time")) {
			esql = "xpath_minutesfromtime("+xPathToESQL(xp)+")";		
			if (!esqlminutesfromtime) {
				esql_minutesfromtime = esql_minutesfromtime+"CREATE FUNCTION xpath_minutesfromtime("+variableTracker+" TIME) RETURNS INTEGER\n";
				esql_minutesfromtime = esql_minutesfromtime+"BEGIN\n";		
				esql_minutesfromtime = esql_minutesfromtime+"IF ("+variableTracker+" IS NULL) THEN\n";
				esql_minutesfromtime = esql_minutesfromtime+"RETURN NULL;\n";
				esql_minutesfromtime = esql_minutesfromtime+"ELSE\n";
				esql_minutesfromtime = esql_minutesfromtime+"RETURN EXTRACT(MINUTE FROM "+variableTracker+");\n";
				esql_minutesfromtime = esql_minutesfromtime+"END IF;\n";
				esql_minutesfromtime = esql_minutesfromtime+"END;\n\n";				
				esqlminutesfromtime = true;
			}
		}
		
		if (funcName.equals("seconds-from-time")) {
			esql = "xpath_secondsfromtime("+xPathToESQL(xp)+")";	
			if (!esqlsecondsfromtime) {
				esql_secondsfromtime = esql_secondsfromtime+"CREATE FUNCTION xpath_secondsfromtime("+variableTracker+" TIME) RETURNS DECIMAL\n";
				esql_secondsfromtime = esql_secondsfromtime+"BEGIN\n";		
				esql_secondsfromtime = esql_secondsfromtime+"IF ("+variableTracker+" IS NULL) THEN\n";
				esql_secondsfromtime = esql_secondsfromtime+"RETURN NULL;\n";
				esql_secondsfromtime = esql_secondsfromtime+"ELSE\n";
				esql_secondsfromtime = esql_secondsfromtime+"RETURN CAST(EXTRACT(SECOND FROM "+variableTracker+") AS DECIMAL);\n";
				esql_secondsfromtime = esql_secondsfromtime+"END IF;\n";
				esql_secondsfromtime = esql_secondsfromtime+"END;\n\n";				
				esqlsecondsfromtime = true;
			}
		}

		if (funcName.equals("years-from-duration")) {
			esql = "xpath_yearsfromduration("+xPathToESQL(xp)+")";	
			if (!esqlyearsfromduration) {
				esql_yearsfromduration = esql_yearsfromduration+"CREATE FUNCTION xpath_yearsfromduration("+variableTracker+" INTERVAL) RETURNS INTEGER\n";
				esql_yearsfromduration = esql_yearsfromduration+"BEGIN\n";		
				esql_yearsfromduration = esql_yearsfromduration+"IF ("+variableTracker+" IS NULL) THEN\n";
				esql_yearsfromduration = esql_yearsfromduration+"RETURN NULL;\n";
				esql_yearsfromduration = esql_yearsfromduration+"ELSE\n";
				esql_yearsfromduration = esql_yearsfromduration+"RETURN CAST(EXTRACT(YEAR FROM "+variableTracker+") AS INTEGER);\n";
				esql_yearsfromduration = esql_yearsfromduration+"END IF;\n";
				esql_yearsfromduration = esql_yearsfromduration+"END;\n\n";				
				esqlyearsfromduration = true;
			}
		}

		if (funcName.equals("months-from-duration")) {
			esql = "xpath_monthsfromduration("+xPathToESQL(xp)+")";		
			if (!esqlmonthsfromduration) {
				esql_monthsfromduration = esql_monthsfromduration+"CREATE FUNCTION xpath_monthsfromduration("+variableTracker+" INTERVAL) RETURNS INTEGER\n";
				esql_monthsfromduration = esql_monthsfromduration+"BEGIN\n";		
				esql_monthsfromduration = esql_monthsfromduration+"IF ("+variableTracker+" IS NULL) THEN\n";
				esql_monthsfromduration = esql_monthsfromduration+"RETURN NULL;\n";
				esql_monthsfromduration = esql_monthsfromduration+"ELSE\n";
				esql_monthsfromduration = esql_monthsfromduration+"RETURN CAST(EXTRACT(MONTH FROM "+variableTracker+") AS INTEGER);\n";
				esql_monthsfromduration = esql_monthsfromduration+"END IF;\n";
				esql_monthsfromduration = esql_monthsfromduration+"END;\n\n";				
				esqlmonthsfromduration = true;
			}
		}
		
		if (funcName.equals("days-from-duration")) {
			esql = "xpath_daysfromduration("+xPathToESQL(xp)+")";
			if (!esqldaysfromduration) {
				esql_daysfromduration = esql_daysfromduration+"CREATE FUNCTION xpath_daysfromduration("+variableTracker+" INTERVAL) RETURNS INTEGER\n";
				esql_daysfromduration = esql_daysfromduration+"BEGIN\n";		
				esql_daysfromduration = esql_daysfromduration+"IF ("+variableTracker+" IS NULL) THEN\n";
				esql_daysfromduration = esql_daysfromduration+"RETURN NULL;\n";
				esql_daysfromduration = esql_daysfromduration+"ELSE\n";
				esql_daysfromduration = esql_daysfromduration+"RETURN CAST(EXTRACT(DAY FROM "+variableTracker+") AS INTEGER);\n";
				esql_daysfromduration = esql_daysfromduration+"END IF;\n";
				esql_daysfromduration = esql_daysfromduration+"END;\n\n";				
				esqldaysfromduration = true;
			}
		}
		
		if (funcName.equals("hours-from-duration")) {
			esql = "xpath_hoursfromduration("+xPathToESQL(xp)+")";
			if (!esqlhoursfromduration) {
				esql_hoursfromduration = esql_hoursfromduration+"CREATE FUNCTION xpath_hoursfromduration("+variableTracker+" INTERVAL) RETURNS INTEGER\n";
				esql_hoursfromduration = esql_hoursfromduration+"BEGIN\n";		
				esql_hoursfromduration = esql_hoursfromduration+"IF ("+variableTracker+" IS NULL) THEN\n";
				esql_hoursfromduration = esql_hoursfromduration+"RETURN NULL;\n";
				esql_hoursfromduration = esql_hoursfromduration+"ELSE\n";
				esql_hoursfromduration = esql_hoursfromduration+"RETURN CAST(EXTRACT(HOUR FROM "+variableTracker+") AS INTEGER);\n";
				esql_hoursfromduration = esql_hoursfromduration+"END IF;\n";
				esql_hoursfromduration = esql_hoursfromduration+"END;\n\n";				
				esqlhoursfromduration = true;
			}
		}		
		
		if (funcName.equals("minutes-from-duration")) {
			esql = "xpath_minutesfromduration("+xPathToESQL(xp)+")";			
			if (!esqlminutesfromduration) {
				esql_minutesfromduration = esql_minutesfromduration+"CREATE FUNCTION xpath_minutesfromduration("+variableTracker+" INTERVAL) RETURNS INTEGER\n";
				esql_minutesfromduration = esql_minutesfromduration+"BEGIN\n";		
				esql_minutesfromduration = esql_minutesfromduration+"IF ("+variableTracker+" IS NULL) THEN\n";
				esql_minutesfromduration = esql_minutesfromduration+"RETURN NULL;\n";
				esql_minutesfromduration = esql_minutesfromduration+"ELSE\n";
				esql_minutesfromduration = esql_minutesfromduration+"RETURN CAST(EXTRACT(MINUTE FROM "+variableTracker+") AS INTEGER);\n";
				esql_minutesfromduration = esql_minutesfromduration+"END IF;\n";
				esql_minutesfromduration = esql_minutesfromduration+"END;\n\n";				
				esqlminutesfromduration = true;
			}
		}		
		
		if (funcName.equals("seconds-from-duration")) {
			esql = "xpath_secondsfromduration("+xPathToESQL(xp)+")";			
			if (!esqlsecondsfromduration) {
				esql_secondsfromduration = esql_secondsfromduration+"CREATE FUNCTION xpath_secondsfromduration("+variableTracker+" INTERVAL) RETURNS INTEGER\n";
				esql_secondsfromduration = esql_secondsfromduration+"BEGIN\n";		
				esql_secondsfromduration = esql_secondsfromduration+"IF ("+variableTracker+" IS NULL) THEN\n";
				esql_secondsfromduration = esql_secondsfromduration+"RETURN NULL;\n";
				esql_secondsfromduration = esql_secondsfromduration+"ELSE\n";
				esql_secondsfromduration = esql_secondsfromduration+"RETURN CAST(EXTRACT(SECOND FROM "+variableTracker+") AS INTEGER);\n";
				esql_secondsfromduration = esql_secondsfromduration+"END IF;\n";
				esql_secondsfromduration = esql_secondsfromduration+"END;\n\n";				
				esqlsecondsfromduration = true;
			}
		}				
				
		return(esql);
		
	}
	
	
	
	
	
	/**
	 * getElementPath
	 */
	private static String getElementPath() {

		StringBuffer buf = new StringBuffer();		
		int pathLength = elementStack.size();
		
		for(int i=0; i<pathLength; i++) {
			
			int posleftbracket = elementStack.elementAt(i).toString().indexOf('[');
			if (posleftbracket==-1) {posleftbracket=elementStack.elementAt(i).toString().length();}
			if (i==1 && outd.equals("MRM")) {
			//if (i==1 && (outd.equals("MRM") || outd.equals("SOAP") )) {  
				//Don't add message name into tree when output domain is MRM!
				//The following uses of substring are required due to when dealing with For loops
				//the elementStack item may include an index as well.
				buf.append(".");
				if (elementStack.elementAt(i).toString().substring(0,posleftbracket).equals("Properties")) {buf.append(elementStack.elementAt(i).toString());}
				else if (elementStack.elementAt(i).toString().substring(0,posleftbracket).equals("MQMD")) {buf.append(elementStack.elementAt(i).toString());}
				else if (elementStack.elementAt(i).toString().substring(0,posleftbracket).equals("MQCFH")) {buf.append(elementStack.elementAt(i).toString());}
				else if (elementStack.elementAt(i).toString().substring(0,posleftbracket).equals("MQCIH")) {buf.append(elementStack.elementAt(i).toString());}
				else if (elementStack.elementAt(i).toString().substring(0,posleftbracket).equals("MQDLH")) {buf.append(elementStack.elementAt(i).toString());}
				else if (elementStack.elementAt(i).toString().substring(0,posleftbracket).equals("MQIIH")) {buf.append(elementStack.elementAt(i).toString());}
				else if (elementStack.elementAt(i).toString().substring(0,posleftbracket).equals("MQMDE")) {buf.append(elementStack.elementAt(i).toString());}
				else if (elementStack.elementAt(i).toString().substring(0,posleftbracket).equals("MQRFH")) {buf.append(elementStack.elementAt(i).toString());}				
				else if (elementStack.elementAt(i).toString().substring(0,posleftbracket).equals("MQRFH2")) {buf.append(elementStack.elementAt(i).toString());}
				else if (elementStack.elementAt(i).toString().substring(0,posleftbracket).equals("MQRFH2C")) {buf.append(elementStack.elementAt(i).toString());}
				else if (elementStack.elementAt(i).toString().substring(0,posleftbracket).equals("MQRMH")) {buf.append(elementStack.elementAt(i).toString());}
				else if (elementStack.elementAt(i).toString().substring(0,posleftbracket).equals("MQSAPH")) {buf.append(elementStack.elementAt(i).toString());}
				else if (elementStack.elementAt(i).toString().substring(0,posleftbracket).equals("MQWIH")) {buf.append(elementStack.elementAt(i).toString());}
				else if (elementStack.elementAt(i).toString().substring(0,posleftbracket).equals("SMQ_BMH")) {buf.append(elementStack.elementAt(i).toString());}
				else if (elementStack.elementAt(i).toString().substring(0,posleftbracket).equals("HTTPInputHeader")) {buf.append(elementStack.elementAt(i).toString());}
				else if (elementStack.elementAt(i).toString().substring(0,posleftbracket).equals("HTTPRequestHeader")) {buf.append(elementStack.elementAt(i).toString());}
				else if (elementStack.elementAt(i).toString().substring(0,posleftbracket).equals("HTTPReplyHeader")) {buf.append(elementStack.elementAt(i).toString());}
				else if (elementStack.elementAt(i).toString().substring(0,posleftbracket).equals("HTTPResponseHeader")) {buf.append(elementStack.elementAt(i).toString());}
				else if (elementStack.elementAt(i).toString().substring(0,posleftbracket).equals("JMSTransport")) {buf.append(elementStack.elementAt(i).toString());}	
				else {
					//InsertOutRootNow= true;
					InsertOutRootNow=InsertOutRootNow+1;
					if (OutBodyRef) {
						// Replace with reference, so need to remove the 11 chars of OutputRoot. from the end
						// Then append the OutBodyRef.
						buf.delete((buf.length()-11),buf.length());
						buf.append("OutBodyRef");
					} else {
						//buf.append("MRM");
						buf.append(outd);
					}
				}
			}
			//else if 	(i==1 && outd!="MRM") {
			else if 	(i==1 && !outd.equals("MRM")) {
			//else if 	(i==1 && (outd!="MRM") || outd!="SOAP" ) {
				buf.append(".");				
				if (elementStack.elementAt(i).toString().substring(0,posleftbracket).equals("Properties")) {buf.append(elementStack.elementAt(i).toString());}
				else if (elementStack.elementAt(i).toString().substring(0,posleftbracket).equals("MQMD")) {buf.append(elementStack.elementAt(i).toString());}
				else if (elementStack.elementAt(i).toString().substring(0,posleftbracket).equals("MQCFH")) {buf.append(elementStack.elementAt(i).toString());}
				else if (elementStack.elementAt(i).toString().substring(0,posleftbracket).equals("MQCIH")) {buf.append(elementStack.elementAt(i).toString());}
				else if (elementStack.elementAt(i).toString().substring(0,posleftbracket).equals("MQDLH")) {buf.append(elementStack.elementAt(i).toString());}
				else if (elementStack.elementAt(i).toString().substring(0,posleftbracket).equals("MQIIH")) {buf.append(elementStack.elementAt(i).toString());}
				else if (elementStack.elementAt(i).toString().substring(0,posleftbracket).equals("MQMDE")) {buf.append(elementStack.elementAt(i).toString());}
				else if (elementStack.elementAt(i).toString().substring(0,posleftbracket).equals("MQRFH")) {buf.append(elementStack.elementAt(i).toString());}				
				else if (elementStack.elementAt(i).toString().substring(0,posleftbracket).equals("MQRFH2")) {buf.append(elementStack.elementAt(i).toString());}
				else if (elementStack.elementAt(i).toString().substring(0,posleftbracket).equals("MQRFH2C")) {buf.append(elementStack.elementAt(i).toString());}
				else if (elementStack.elementAt(i).toString().substring(0,posleftbracket).equals("MQRMH")) {buf.append(elementStack.elementAt(i).toString());}
				else if (elementStack.elementAt(i).toString().substring(0,posleftbracket).equals("MQSAPH")) {buf.append(elementStack.elementAt(i).toString());}
				else if (elementStack.elementAt(i).toString().substring(0,posleftbracket).equals("MQWIH")) {buf.append(elementStack.elementAt(i).toString());}
				else if (elementStack.elementAt(i).toString().substring(0,posleftbracket).equals("SMQ_BMH")) {buf.append(elementStack.elementAt(i).toString());}
				else if (elementStack.elementAt(i).toString().substring(0,posleftbracket).equals("HTTPInputHeader")) {buf.append(elementStack.elementAt(i).toString());}
				else if (elementStack.elementAt(i).toString().substring(0,posleftbracket).equals("HTTPRequestHeader")) {buf.append(elementStack.elementAt(i).toString());}
				else if (elementStack.elementAt(i).toString().substring(0,posleftbracket).equals("HTTPReplyHeader")) {buf.append(elementStack.elementAt(i).toString());}
				else if (elementStack.elementAt(i).toString().substring(0,posleftbracket).equals("HTTPResponseHeader")) {buf.append(elementStack.elementAt(i).toString());}
				else if (elementStack.elementAt(i).toString().substring(0,posleftbracket).equals("JMSTransport")) {buf.append(elementStack.elementAt(i).toString());}
				else if (elementStack.elementAt(i).toString().substring(0,posleftbracket).equals("SOAP_Domain_Msg")) {buf.append("SOAP");}
				else {
					//InsertOutRootNow= true;
					InsertOutRootNow=InsertOutRootNow+1;
					if (OutBodyRef) {
						// Replace with reference, so need to remove the 11 chars of OutputRoot. from the end
						// Then append the OutRef.
						buf.delete((buf.length()-11),buf.length());
						buf.append("OutBodyRef");						
						buf.append(".");
						buf.append(elementStack.elementAt(i));					
					} else {
						buf.append(outd);
						buf.append(".");
						buf.append(elementStack.elementAt(i));
					}			
				
				}
			}
			else {
				if(i>0)	buf.append(".");
				buf.append(elementStack.elementAt(i));}
		}		
		return(buf.toString());
	}
	
	/**
	 * getTab
	 */
	private static String getTab() {

		String spaces = "        ";
		for(int i=0; i<tabCount; i++) {
			spaces = spaces+"    ";
		}	
		return spaces;
	}
	
	/**
	 * addTabCount
	 */
	private static void addTabCount() {
		tabCount++;
	}

	/**
	 * minusTabCount
	 */
	private static void minusTabCount() {		 
		tabCount--;
	}
	
	/**
	 * Substitute in scope references for correlation names used as RHS of SET expressions
	 */
	private static String substituteRefs(String expr) {
		
		// Loop over all the inscope references in the ArrayList and replace any that occur ...	
		// Start from most recently declared reference so that refs used in nested while loops are as efficient as possible 	
		if (!inScopeRefs.isEmpty()) {
			int j = inScopeRefs.size();
			for (int i=0; i<inScopeRefs.size(); i++) {
				j = inScopeRefs.size() - i - 1;
				if (refHashMap.containsKey(inScopeRefs.get(j))) {
					expr = replaceFirstLiteral(expr,refHashMap.get(inScopeRefs.get(j)).toString(), inScopeRefs.get(j).toString());
				}	
			}
		}
		
		if (InBodyRef) {expr = replaceFirstLiteral(expr,"InputRoot."+ind,"InBodyRef");}

		return expr;		
	}	
	
	
	
	
	private static String replaceFirstLiteral(String in, String search, String replace) {
		int idx = in.indexOf(search);
		if(idx==-1)
			return(in);
		else {
			StringBuffer ret = new StringBuffer();
			ret.append(in.substring(0,idx));
			ret.append(replace);
			ret.append(in.substring(idx+search.length()));
			return(ret.toString());
		}
	}
	
	
	
	
	/**
	 * main - Application entry point
	 */
	
	public static String main(String loc,String indomain, String outdomain, String modname, boolean InBRef, boolean OutBRef) 
		throws ParserConfigurationException, SAXException, IOException
	{
		// Take values from wizard ready to be used by generator
		ind = indomain;
		outd = outdomain;
		InBodyRef = InBRef;
		OutBodyRef = OutBRef;
		
		// Initialise XML classes and settings if necessary
		if(!setupDone) {
			doSetup();
		}
		esqlBuf.delete(0,esqlBuf.length());

		esqlBuf.append("-- This file contains ESQL generated from a msgmap mapping file\n\n");
		esqlBuf.append("CREATE COMPUTE MODULE "+modname+"_Compute\n\n");
		esqlBuf.append(getTab()+"CREATE FUNCTION Main() RETURNS BOOLEAN\n");
		esqlBuf.append(getTab()+"BEGIN\n\n");
		addTabCount();
		if (InBodyRef) {esqlBuf.append(getTab()+"DECLARE InBodyRef REFERENCE TO InputRoot."+ind+";\n");}
			
					
		try {
			Document msgmap = builder.parse(loc);
			Node root = msgmap.getFirstChild();			
			Node mapoperation = searchForChild(root,"maplang:MapOperation",null,null,false);
			NodeList children = mapoperation.getChildNodes();
			int numChildren = children.getLength();
			for(int i=0; i<numChildren; i++) {
				Node child = children.item(i);
				String childname = child.getNodeName();
				if(childname.equals("namespaces")) {
					String nsuri = getAttrValue(child, "namespaceName");
					String nsprefix = getAttrValue(searchForChild(child,"prefix",null,null,false),"prefixName");
					esqlBuf.append(getTab()+"DECLARE "+nsprefix+" NAMESPACE '"+nsuri+"';\n");					
				}
				
			}
				
			
			walk(root);
			
			
		} catch (Exception e) {
			log("Hit Exception! "+e.toString());
		}

		minusTabCount();
		esqlBuf.append("\n"+getTab()+"RETURN TRUE;\n");
		esqlBuf.append(getTab()+"END;\n\n");		
		
		if (esqlempty) {esqlBuf.append(esql_empty);}
		if (esqlexists) {esqlBuf.append(esql_exists);}
		if (esqlyearfromdateTime) {esqlBuf.append(esql_yearfromdateTime);}
		if (esqlmonthfromdateTime) {esqlBuf.append(esql_monthfromdateTime);}
		if (esqldayfromdateTime) {esqlBuf.append(esql_dayfromdateTime);}
		if (esqlhoursfromdateTime) {esqlBuf.append(esql_hoursfromdateTime);}
		if (esqlminutesfromdateTime) {esqlBuf.append(esql_minutesfromdateTime);}
		if (esqlsecondsfromdateTime) {esqlBuf.append(esql_secondsfromdateTime);}
		if (esqlyearfromdate) {esqlBuf.append(esql_yearfromdate);}
		if (esqlmonthfromdate) {esqlBuf.append(esql_monthfromdate);}
		if (esqldayfromdate) {esqlBuf.append(esql_dayfromdate);}
		if (esqlhoursfromtime) {esqlBuf.append(esql_hoursfromtime);}
		if (esqlminutesfromtime) {esqlBuf.append(esql_minutesfromtime);}
		if (esqlsecondsfromtime) {esqlBuf.append(esql_secondsfromtime);}
		if (esqlyearsfromduration) {esqlBuf.append(esql_yearsfromduration);}
		if (esqlmonthsfromduration) {esqlBuf.append(esql_monthsfromduration);}
		if (esqldaysfromduration) {esqlBuf.append(esql_daysfromduration);}
		if (esqlhoursfromduration) {esqlBuf.append(esql_hoursfromduration);}
		if (esqlminutesfromduration) {esqlBuf.append(esql_minutesfromduration);}
		if (esqlsecondsfromduration) {esqlBuf.append(esql_secondsfromduration);}
		
		//Reset things in case wizard is run again
		elementStack.clear();
		elementStack.push("OutputRoot");
		variableTracker = "A";
		variableNumber = 1;
		loopHashMap.clear();
		occursHashMap.clear();
		//InsertOutRootNow= false;
		InsertOutRootNow = 0;
		OutRootInsertPoint = 0;
		OutRootIfInsert = "";		
		OutRootDecAlreadyExists = false;
		OutRootDecAlreadyExistsIf = false;
		InBodyRef		= false;
		OutBodyRef		= false;		
		esqlempty = false;
		esql_empty = "";		
		esqlexists = false;
		esql_exists = "";
		esqlnot = false;		
		esql_not = "";		
		esqlyearfromdateTime = false;
		esql_yearfromdateTime = "";				
		esqlmonthfromdateTime = false;
		esql_monthfromdateTime = "";		
		esqldayfromdateTime = false;
		esql_dayfromdateTime = "";
		esqlhoursfromdateTime = false;
		esql_hoursfromdateTime = "";
		esqlminutesfromdateTime = false;
		esql_minutesfromdateTime = "";
		esqlsecondsfromdateTime = false;
		esql_secondsfromdateTime = "";
		esqlyearfromdate = false;
		esql_yearfromdate = "";
		esqlmonthfromdate = false;
		esql_monthfromdate = "";
		esqldayfromdate = false;
		esql_dayfromdate = "";
		esqlhoursfromtime = false;
		esql_hoursfromtime = "";
		esqlminutesfromtime = false;
		esql_minutesfromtime = "";
		esqlsecondsfromtime = false;
		esql_secondsfromtime = "";
		esqlyearsfromduration = false;
		esql_yearsfromduration = "";
		esqlmonthsfromduration = false;
		esql_monthsfromduration = "";
		esqldaysfromduration = false;
		esql_daysfromduration = "";
		esqlhoursfromduration = false;
		esql_hoursfromduration = "";
		esqlminutesfromduration = false;
		esql_minutesfromduration = "";
		esqlsecondsfromduration = false;
		esql_secondsfromduration = "";
		
//		minusTabCount();
//		esqlBuf.append("\n"+getTab()+"RETURN TRUE;\n");
//		esqlBuf.append(getTab()+"END;\n\n");
		esqlBuf.append("END MODULE;");
		
		return(esqlBuf.toString());
		
	}
 
}
