package map2esql.wizards;

import map2esql.popup.actions.Map2ESQL;

import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.wizard.Wizard;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.*;
import org.eclipse.core.runtime.*;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.core.resources.*;
import org.eclipse.core.runtime.CoreException;
import java.io.*;


public class Map2esqlWizard extends Wizard implements INewWizard {
	private Map2esqlWizardPage page;
	private ISelection selection;
	
	public static String indomain = "MRM";
	public static String outdomain = "MRM";
	public static boolean InBRef = false;
	public static boolean OutBRef = false;
	
	/**
	 * Constructor for SampleNewWizard.
	 */
	public Map2esqlWizard() {
		super();		
		setNeedsProgressMonitor(true);
		setWindowTitle("Map to ESQL - Generate ESQL");
	}
	
	/**
	 * Adding the page to the wizard.
	 */
	public void addPages() {
		page = new Map2esqlWizardPage(selection);
		addPage(page);
	}

	/**
	 * This method is called when 'Finish' button is pressed in
	 * the wizard. We will create an operation and run it
	 * using wizard as execution context.
	 */
	public boolean performFinish() {
				
		Shell shell = new Shell();
		IWorkbenchWindow activeWindow = PlatformUI.getWorkbench().getActiveWorkbenchWindow();
		ISelection sel = activeWindow.getActivePage().getSelection();
		Object object = ((IStructuredSelection)sel).getFirstElement(); 
	    IAdaptable iadap = (IAdaptable) object;
	    Object adapter = iadap.getAdapter(IResource.class);
	    IResource res = (IResource) adapter;
	    String loc = res.getLocation().toOSString();
	    IWorkspaceRoot root = ResourcesPlugin.getWorkspace().getRoot();
		IProject proj = res.getProject();
		String outfilename = "Generated_"+res.getName().replaceAll(res.getFileExtension(),"esql");		
		IFile outfile = proj.getFile(new Path(outfilename));
		IProgressMonitor mon = null;
		
		try {
			InputStream str = new ByteArrayInputStream("".getBytes());
			try {
				outfile.create(str, true, mon);
			} catch (CoreException ce) {
				System.out.println(ce.toString());
			}
			str.close();
		} catch (IOException e) {
			System.out.println(e.toString());	
		}
	    
		try {
			
			String esql = Map2ESQL.main(loc,indomain,outdomain,res.getName().replaceAll("."+res.getFileExtension(),""),InBRef,OutBRef);
			outfile.setContents(new ByteArrayInputStream(esql.getBytes()),false,true,mon);			
		} catch (Exception e) {
			System.out.println(e.toString());
		}
		
		return true;
	}

	public static void setInBRef(boolean result) {
		InBRef = result; }	
	
	public static void setOutBRef(boolean result) {
		OutBRef = result; }
	
	public static void setIndomain(String result) {
		indomain = result; }

	public static void setOutdomain(String result) {
		outdomain = result; }
			
	/**
	 * We will accept the selection in the workbench to see if
	 * we can initialize from it.
	 * @see IWorkbenchWizard#init(IWorkbench, IStructuredSelection)
	 */
	public void init(IWorkbench workbench, IStructuredSelection selection) {
		this.selection = selection;
	}
}